<template>
  <div class="object-fill referral-diagram" v-loading="isLoading">
    <div class="w-full min-h-[20vh]">
      <el-scrollbar>
        <el-tree
          :data="treeData"
          :props="props"
          :height="208"
          label
          @node-expand="expandNode"
          @node-collapse="collapeNode"
        >
          <template #default="{ data }">
            <div
              class="flex flex-col w-[420px] h-fit bg-background2 rounded-lg"
            >
              <div
                class="flex justify-between items-center pt-4 pb-2 px-5 border-b"
              >
                <div>
                  <span class="mr-2">
                    <font-awesome-icon v-if="data.Layer === 0" icon="star" />
                    <font-awesome-icon v-else icon="users" />
                  </span>
                  <span class="text-md font-bold"
                    >{{ data.Username }} / {{ data.Currency }}</span
                  >
                </div>
                <div class="flex items-center">
                  +{{ data.ChildCount }}
                  <div class="flex justify-center items-center ml-2 text-xl">
                    <font-awesome-icon
                      v-if="!data.IsExpand && data.ChildCount >= 0"
                      icon="circle-plus"
                    />
                    <font-awesome-icon v-else icon="circle-minus" />
                  </div>
                </div>
              </div>
              <div class="flex flex-col pb-5 pt-2 px-5">
                <div class="flex justify-between">
                  <div>This / Last Month Turnover :</div>
                  <div class="flex">
                    <span class="mr-3"
                      >{{ data.ThisMonthTurnoverForDisplay }} /
                      {{ data.LastMonthTurnoverForDisplay }}</span
                    >
                    <span :class="data.TurnoverMarginColor"
                      >{{ data.TurnoverMarginPercentage }} %</span
                    >
                  </div>
                </div>
                <div class="flex justify-between">
                  <div>This / Last Month Net Turnover :</div>
                  <div class="flex">
                    <span class="mr-3"
                      >{{ data.ThisMonthNetTurnoverForDisplay }} /
                      {{ data.LastMonthNetTurnoverForDisplay }}</span
                    >
                    <span :class="data.NetTurnoverMarginColor"
                      >{{ data.NetTurnoverMarginPercentage }} %</span
                    >
                  </div>
                </div>
              </div>
            </div>
          </template>
        </el-tree>
      </el-scrollbar>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { ITreeNode } from "@/models/referral/getReferral";

export default defineComponent({
  components: {},
  setup() {
    const { treeData, isLoading } = useReferralDiagram();
    const props = {
      value: "CustomerId",
      label: "Currency",
      username: "Username",
      children: "Children",
    };
    const expandNode = (node: ITreeNode) => {
      node.IsExpand = true;
    };
    const collapeNode = (node: ITreeNode) => {
      node.IsExpand = false;
    };
    return {
      treeData,
      isLoading,
      props,
      expandNode,
      collapeNode,
    };
  },
});
</script>
<style lang="scss" scoped>
:deep(.el-tree) {
  background: none;
  .el-tree-node__children {
    .el-tree-node__content::before {
      content: "" !important;
      height: 3000000px !important;
      width: 10px !important;
      border-left: 1px solid var(--border) !important;
      border-bottom: 1px solid var(--border) !important;
      border-radius: 0 0 0 7px !important;
      margin-bottom: 3000000px !important;
    }
  }
  .el-tree-node__content {
    margin: 0px 0 0 20px;
    height: 140px;
    width: fit-content;
    position: relative;
  }
  .el-tree-node__content:hover {
    background: none;
  }
  .el-icon {
    display: none;
  }
}
:deep(.el-scrollbar) {
  padding-bottom: 65px;
}
</style>
